# Method: projects.topics.publish

- [HTTP request](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.PublishResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#body.aspect)
- [Try it!](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics/publish#try-it)

Adds one or more messages to the topic. Returns `NOT_FOUND` if the topic does not exist.

### HTTP request

Choose a location:
<button value="global" default="">global</button>   
`POST https://pubsub.googleapis.com/v1/{topic}:publish`

<br />

### Path parameters

| Parameters ||
|---|---|
| `topic` | `string` Required. The messages in the request will be published on this topic. Format is `projects/{project}/topics/{topic}`. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "messages": [ { object (`https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/PubsubMessage`) } ] } ``` |

| Fields ||
|---|---|
| `messages[]` | ``object (`https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/PubsubMessage`)`` Required. The messages to publish. |

### Response body

Response for the `topics.publish` method.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "messageIds": [ string ] } ``` |

| Fields ||
|---|---|
| `messageIds[]` | `string` Optional. The server-assigned ID of each published message, in the same order as the messages in the request. IDs are guaranteed to be unique within the topic. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/pubsub`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).